/*mt 19937*/

#include<stdio.h>
#define AN 624
#define M 397
#define MATRIX_A 0x9908b0df   /*Constant vector a*/
#define UPPER_MASK 0x80000000 /*Most significant w-r bits*/
#define LOWER_MASK 0x7fffffff /* Least Significant r bits*/

/*Tempering Parameters*/

#define TEMPERING_MASK_B 0x9d2c5680
#define TEMPERING_MASK_C 0xefc60000
#define TEMPERING_SHIFT_U(y) (y>>11)
#define TEMPERING_SHIFT_S(y) (y<<7)
#define TEMPERING_SHIFT_T(y) (y<<15)
#define TEMPERING_SHIFT_L(y) (y>>18)

static unsigned long mt[AN];  /*the array for the state vector*/
static int mti=AN+1;          /*mti==N+1 means mt[N] is not 
initialised*/
int intval=0;
/*initilaizing the array with a NONZERO seed*/

void sgenrand(seed)
unsigned long seed;
{
    mt[0]=seed & 0xffffffff;
    for(mti=1;mti<AN;mti++)
    mt[mti]=(69069*mt[mti-1]) & 0xffffffff;
}


double genrand()
{
    unsigned long y;
    static unsigned long mag01[2]={0x0,MATRIX_A};
    if(mti>=AN)
    {
        int kk;
        if(mti==AN+1)
            sgenrand(4357);
        for(kk=0;kk<AN-M;kk++)
        {
            y=(mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
            mt[kk]=mt[kk+M]^(y>>1)^mag01[y & 0x1];
        }
        for(;kk<AN-1;kk++)
        {
            y=(mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
            mt[kk]=mt[kk+(M-AN)]^(y>>1)^mag01[y & 0x1];
        }
       y=(mt[AN-1] & UPPER_MASK) |(mt[0]&LOWER_MASK);
       mt[AN-1]=mt[M-1]^(y>>1)^mag01[y & 0x1];
       mti=0;
    }
    y=mt[mti++];
    y ^=TEMPERING_SHIFT_U(y);
    y ^=TEMPERING_SHIFT_S(y) & TEMPERING_MASK_B;
    y ^=TEMPERING_SHIFT_T(y) & TEMPERING_MASK_C;
    y ^=TEMPERING_SHIFT_L(y);
  
    return( (double) y/(unsigned long)0xffffffff);
}

int call()
{
   int j;
   int times;  //number of times//
   int seedval;
    //integer conversion of real//
   
   //printf(" Enter the number of times:");
   //scanf("%d",&times);

   printf("\n Enter the seed value:");
   scanf("%d",&seedval);
   
   sgenrand(seedval);
//   for(j=0;j<times;j++)
  // {
       intval=genrand()*100000000;
        
       printf("%5d ",intval );
    //   if(j%8==7)
      printf("\n");
      return(intval);  
   //}
printf("\n");
}
